include "src/gb.inc"

global draw_bg, puthex, putnibble

SECTION "rom_bg", ROM0

; Background drawing ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

draw_bg:
  ; Fill CHR RAM
  ld hl,bggfx_chr
  ld de,CHRRAM2
  ld bc,16*96
  call memcpy

  ; Clear nametable
  ld h, 0
  ld de, NTRAM0
  ld bc, 1024
  call memset

  ; Draw top of floor
  ld h,$0B
  ld de,NTRAM0+32*16
  ld bc,20
  call memset
  
  ; Draw bottom of floor
  ld h,$01
  ld de,NTRAM0+32*17
  ld bc,20
  call memset

  ld hl,NTRAM0+32*12+1
  call bg_draw_one_block
  ld hl,NTRAM0+32*14+1
  call bg_draw_one_block
  ld hl,NTRAM0+32*12+17
  call bg_draw_one_block
  ld hl,NTRAM0+32*14+17
  call bg_draw_one_block

  ; Write initial A and B values
  ld hl,NTRAM0+32*0+16
  ld a,"A"
  ld [hl+],a
  ld a,":"
  ld [hl+],a
  ld a,[initial_a]
  call puthex
  ld hl,NTRAM0+32*1+16
  ld a,"B"
  ld [hl+],a
  ld a,":"
  ld [hl+],a
  ld a,[initial_b]
  call puthex


  ; Set palette
  ld a, %01101100
  ldh [BGP],a
  ret

bg_draw_one_block:
  ld a,$0C
  ld [hl+],a
  inc a
  ld [hl-],a
  inc a
  set 5,l
  ld [hl+],a
  inc a
  ld [hl-],a
  inc a
  ret

;;
; Writes two hex nibbles ("0123456789ABCDEF") to HL
puthex:
  push af
  swap a
  and $0F
  call putnibble
  pop af
  and $0F
putnibble:
  cp $0A
  jr c,.not_letter
  add ("A"-"9"-1)
.not_letter:
  add "0"
  ld [hl+],a
  ret

bggfx_chr: incbin "obj/gb/bggfx.chrgb"
